/**********************************************************************
SQL Server Internals from the Practical Angle

Dmitri Korotkevitch
http://aboutsqlserver.com
dmitri@aboutsqlserver.com

Locking and Blocking: Transaction Isolation Levels and Lock Behavior (Session 2)
**********************************************************************/

use TroubleshootingDb
go

set nocount on
go

-- Open SQL Profiler with the following events:
-- Locks:\Lock Acquired, Locks:\Lock Released
-- Set filter for SPID

-- Read Uncommitted
set transaction isolation level read uncommitted
select * from dbo.SmallRow where ID = 100
go

-- Read Committed
set transaction isolation level read committed
begin tran
	select * from dbo.SmallRow where ID between 90 and 100
	select * from sys.dm_tran_locks where request_session_id = @@SPID
commit
go

-- Repeatable Read
set transaction isolation level repeatable read
begin tran
	select * from dbo.SmallRow where ID between 90 and 100
	select * from sys.dm_tran_locks where request_session_id = @@SPID
commit
go

set transaction isolation level serializable
begin tran
	select * from dbo.SmallRow where ID between 90 and 100
	select * from sys.dm_tran_locks where request_session_id = @@SPID
commit
go

-- Troubleshooting
set transaction isolation level read committed
select * from dbo.SmallRow where IntField = 1
go

